// Пример, демонстрирующий работу модуля АЦП QMS20
// (собирает данные с 4х каналов с частотой 300 кГц/канал)
// В примере иллюстрируется применение основных библиотечных
//функций и правильная очередность их вызова.

#include "../../dll/qmx.h"
#include <shellapi.h>
#include <stdio.h>
#include <conio.h> 


HANDLE SD;                              // Дескриптор системы
QMX_CONFIG CFG;                         // Конфигурация системы
WORD QMS20Table[16];					// Таблица опроса каналов для QMS20
QMX_CC_F CC_Adc1[4];					// Калибровочные коэффициенты

static unsigned int DataPtr, DataPtrOld, CurrentPtr, LengthDataBuf;
static unsigned short int *Data;



static unsigned int QMS_data[8][32], QMS_iter[8][32], time;

void CheckErr(void);
void quit(void);
void DisplayData(void);

//void main(void)
void main(int argc, char* argv[])
{
	char s_wrk[64];
	int i_wrk, mod, ch;
	double CRate;

	printf("Please wait....\r");
	
	// Запустим сервер
	ShellExecuteW(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-p3"), NULL, SW_SHOWNORMAL);
	Sleep(500);

	// Получим дискриптор системы
	SD = 0;
	SD=QMX_CircBufAttach(0);
	if (SD == NULL) {
		printf("ERROR: No QMBox found.");
		quit(); 
	}

	// Проинициализуем систему
	QMX_InitModules(SD, QMX_LOG_NONE, NULL);
	CheckErr();

	// Фиктивный вызов QMX_Prepare - выясним конфигурацию устройства
	// т.е. из каких модулей оно состоит
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	QMX_MOD_SetActive(SD, 0, QMX_OFF);
	
	// Убедимся, что в нулевом слоте устройства - модуль QMS20
	strncpy_s (s_wrk, CFG.ModName[0], 5); s_wrk[5] = 0;
	if (!_stricmp(s_wrk, "QMS20"))	printf("Module name OK\n");
	else{ printf("Module Name error\n");	quit();	}
	

	// Установим частоту работы АЦП
	QMX_QMS20_SetAdcRate(SD, 0, 3000000, &CRate); 
	printf("ADC  Rate = %8.2f Hz \n", CRate);	

	// Считаем из ППЗУ АЦП колибровочные коэффициенты
	// Четырех первых входных каналов для диапазона +-5 В.
	for (i_wrk=0; i_wrk<4; i_wrk++) QMX_QMS20_ReadCC(SD, 0, i_wrk, QMX_QMS20_GAIN_1, &CC_Adc1[i_wrk]);

	// Заполним таблицу опроса модуля QMS20:
	// в сеансе сбора данных будут участвовать 4 первых каналов устройства - 
	// все с усилениями 1
	QMX_QMS20_BuildTableItem(SD, 0, QMX_QMS20_MODE_D, QMX_QMS20_GAIN_1,  &QMS20Table[0]);
	QMX_QMS20_BuildTableItem(SD, 1, QMX_QMS20_MODE_D, QMX_QMS20_GAIN_1,  &QMS20Table[1]);
	QMX_QMS20_BuildTableItem(SD, 2, QMX_QMS20_MODE_D, QMX_QMS20_GAIN_1,  &QMS20Table[2]);
	QMX_QMS20_BuildTableItem(SD, 3, QMX_QMS20_MODE_D, QMX_QMS20_GAIN_1,  &QMS20Table[3]);

	// Запишем таблицу опроса в модуль
	QMX_QMS20_SetTable(SD, 0, QMS20Table, 4);
	// Объявим АЦП активным
	QMX_MOD_SetActive(SD, 0, QMX_ON);

	// Подготовимся к сбору данных
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	
	LengthDataBuf = *CFG.CBInput.buf_size;						// размер кольцевого буфера данных, заполняемого сервером
	Data = (unsigned short int*)CFG.CBInput.buf_start;			// указатель на начало кольцевого буфера данных,
																// заполняемого сервером
	DataPtrOld = 0;
	time = 0;

	// Запустим сбор данных
	QMX_Start(SD);
	CheckErr();

	while (!_kbhit()){											// цикл непрерывного сбора данных
																// (до нажатия кнопки клавиатуры)

		DataPtr = *CFG.CBInput.buf_ptr;							//получим значение указателя на последний 
																// полученный элемент данных						
		for (CurrentPtr = DataPtrOld; CurrentPtr != DataPtr; CurrentPtr += 2) { // цикл считывания всех полученных элементов данных
			
			if(CurrentPtr >= *CFG.CBInput.buf_size)				// Проверки, необходимые
				CurrentPtr = 0;									// чтобы текущий указатель 
			if ((!CurrentPtr)&&(!DataPtr))break;				// не перескочил через границу буфера

			mod = (Data[CurrentPtr] >> 5) & 0x07;				// в четном (младшем) 16-ти битном слове элемента данных содержится 
			ch  = Data[CurrentPtr]  & 0x1f;						// информация о номерах канала (младщие 5-ть бит) и модуля (сл. 3-ри бита).
			QMS_data[mod][ch] += Data[CurrentPtr+1];			// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// информация о величине сигнала измеренного в данном канале данного модуля
																// (в кодах АЦП).
																// в настоящем примере измерения интегрируются в соответствующей ([модуль][канал])
																// ячейке массива накопления. В реальной программе пользователя измерения могут
																// перемещаться в поканальные массивы без усреднения, для дальнейшей обработки или
																// записи в выходные файлы.
			QMS_iter[mod][ch]++;								// счетчик количества суммирований для данного канала
	
		}

		DataPtrOld = DataPtr;						// запоминание предыдущего указателя на последний полученный
													// элемент данных

		time++;										// счетчик количества 100 мс интервалов
		if (time >=5){								// если накопление длится более 0.5 с,
			DisplayData();							// произвести отображение результатов измерений
			time = 0;								// обнуление счетчика количества 100 мс интервалов
		}

		Sleep(50);									// Ожидание следующей порции данных от сервера 
													// В реальной программе в этом месте вместо Sleep может производится
													// обработка полученных данных и их запись в файл

 }

	quit();											// выход из программы
}


// Выход из программы
void quit(void){
	
	printf("\n\n Please wait....\r");
	QMX_Stop(SD, QMX_STOP_ALL);			// Остановим систему
	QMX_MOD_SetStartMode(SD, 0xFF, QMX_START_MODE_MANUAL); 									

	QMX_CircBufDetach(SD);              // Освободим виртуальный слот USB
										// Остановим сервер
	ShellExecute(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-s0"), NULL, SW_SHOWNORMAL);
	printf("\n\n");
	ExitProcess(0);
}


// Проверка на ошибки
void CheckErr(void) {
char tmp_str[1024];

if (QMX_GetLastError(SD, tmp_str, sizeof(tmp_str))==QMX_OK){ return;}
else  {	printf("%s\n", tmp_str);	quit();}
}


// Отображение данных
void DisplayData(void){

	double d_wrk;

	// вычисление усредненных значений результатов измерений, приведение их к Вольтам при помощи 
	// калибровочных коэффициентов и печать на консоль :
	d_wrk = ((double)QMS_data[0][0]) / ((double)QMS_iter[0][0]) * CC_Adc1[0].Scale + CC_Adc1[0].Offset;
	printf("Data from ADC: %6.3f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][1]) / ((double)QMS_iter[0][1]) * CC_Adc1[1].Scale + CC_Adc1[1].Offset;
	printf("%6.3f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][2]) / ((double)QMS_iter[0][2]) * CC_Adc1[2].Scale + CC_Adc1[2].Offset;
	printf("%6.3f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][3]) / ((double)QMS_iter[0][3]) * CC_Adc1[0].Scale + CC_Adc1[0].Offset;
	printf("%6.3f V\r", d_wrk);
	
	// обнуление рабочих ячеек усреднения результатов измерений :
	QMS_data[0][0] = 0; QMS_iter[0][0] = 0; 
	QMS_data[0][1] = 0; QMS_iter[0][1] = 0;
	QMS_data[0][2] = 0; QMS_iter[0][2] = 0;
	QMS_data[0][3] = 0; QMS_iter[0][3] = 0;
}



